#include "mess822.h"
#include "buffer.h"
#include "logmsg.h"
#include "exit.h"

#define WHO "quote"

void nomem()
{
  logmsg(WHO,111,FATAL,"out of memory");
}

stralloc quoted = {0};
stralloc addr = {0};
char *comment = 0;

int main(int argc,char **argv)
{
  if (!stralloc_copys(&addr,"@")) nomem();

  if (argv[1]) {
    if (!stralloc_copys(&addr,argv[1])) nomem();
    if (!stralloc_cats(&addr,"@")) nomem();

    if (argv[2]) {
      if (!stralloc_cats(&addr,argv[2])) nomem();

      comment = argv[3];
    }
  }

  if (!stralloc_0(&addr)) nomem();
  if (!mess822_quote(&quoted,addr.s,comment)) nomem();

  if (!stralloc_append(&quoted,"\n")) nomem();

  buffer_putflush(buffer_1,quoted.s,quoted.len);

  _exit(0);
}
